#-------------------------------------------------------------------------------
# Name:        registerVisualiser
# Purpose:
#
# Author:      dccharacter
#
# Created:     14.03.2012
# Copyright:   (c) dccharacter 2012
# Licence:     <your licence>
#-------------------------------------------------------------------------------
#!/usr/bin/env python

from tkinter import *
from tkinter.ttk import *

class regToken(Frame):
    def __init__(self, master, regName='someReg', regValues=[], regTips=[], cnf={}, **kw):
        Frame.__init__(self,master, *cnf, **kw)
        self.Label = Label(self, text=regName).grid(row=0, column=0)
        self.Combobox = Combobox(self, values=regValues, width=len(regValues[0])+1).grid(row=1, column=0)
        self.Label2 = Label(self, text=str("\n").join(regTips)).grid(row=2, column=0)

class regVis(LabelFrame):
    def __init__(self, master, regName='someReg', regAddr='someAddr', cnf={}, **kw):
        LabelFrame.__init__(self,master, text=regName, *cnf, **kw)
        self.style = Style()
        self.style.layout("regName.TLabel")
        Label(self, text=regAddr+'\n'+regName, style="regName.TLabel").grid(column=0, row=0)
        regToken(self, regName='Res.', regValues=['Res.'], regTips=['Res.']).grid(column=2, row=0)
        regToken(self, regName='TDE', regValues=['0','1'], regTips=['0: Trigger DMA Request disabled','1: Trigger DMA Request disabled']).grid(column=1, row=0)
        regToken(self, regName='x2', regValues=['ad','sw'], regTips=['ad','sw']).grid(column=3, row=0)
        regToken(self, regName='x2', regValues=['a','w'], regTips=['a','w']).grid(column=4, row=0)
        regToken(self, regName='x2', regValues=['asdf','wwww'], regTips=['asdf','wwww']).grid(column=5, row=0)
        regToken(self, regName='x2', regValues=['a','w'], regTips=['a','w']).grid(column=6, row=0)
        regToken(self, regName='x2', regValues=['adddd','wdwww'], regTips=['adddd','wdwww']).grid(column=7, row=0)
        regToken(self, regName='x2', regValues=['a','w'], regTips=['a','w']).grid(column=8, row=0)

class Register(object):
    __regName__='dummyName'
    __regAddress__='0x00'
    __result__={}
    __numOfGroups__=0

    def __init__(self):
        pass

    def setRegisterName(self, registerName):
        self.__regName__=registerName

    def setRegisterAddress(self, registerAddress):
        self.__regAddress__=repr(registerAddress)

    def get(self):
        return self.__result__

    def addGroups(self, listOfGroups):
        positionCounter = len(self.__result__)
        for group in listOfGroups:
            print(self.__result__.values().values())
            self.__result__[positionCounter]=dict(groupName=group)
            positionCounter = positionCounter+1

    def setGroupValues(self, groupName, listOfValues):
        groupIndex = -1
        for index in self.__result__:
            if self.__result__[index]['groupName'] == groupName:
                groupIndex=index
        if groupIndex==-1:
            print ("No such group:",groupName,". Values  were not added.")
        else:
           self.__result__[groupIndex]["values"] = listOfValues



    def setGroupTips(self, groupName, listOfTips):
        groupIndex = -1
        for index in self.__result__:
            if self.__result__[index]['groupName'] == groupName:
                groupIndex=index
        if groupIndex==-1:
            print ("No such group:",groupName,". Tips were not added.")
        else:
            self.__result__[groupIndex]["tips"] = listOfTips



def main():
    root = Tk()
    mainWindow = Frame(root)
    mainWindow.pack()
    regVis(mainWindow, regName="OSCCON", regAddr="0x0C").pack()

    root.mainloop()

if __name__ == '__main__':
    main()
